%define _unpackaged_files_terminate_build 0
%define peardir /usr/share/php/pear
%define cliopt -d safe_mode_exec_dir=""

%define xmlrpcver  1.5.5
%define getoptver  1.4.1
%define arctarver  1.4.3
%define structver  1.1.1
%define xmlutil    1.4.3
%define eprintver  1.0.6
%define esystemver 1.0.2
%define efilever   1.0.4
%define ogetoptver 1.0.3
%define myexcepver 1.0.1

%define withpear 1

%define esystem http://mirror.oops.org/pub/oops/php/pear/eSystem/eSystem-%{esystemver}.tgz
%define efilesystem http://ftp.oops.org/pub/oops/php/pear/eFilesystem/eFilesystem-%{efilever}.tgz
%define ogetopt http://ftp.oops.org/pub/oops/php/pear/oGetopt/oGetopt-%{ogetoptver}.tgz
%define eprint http://ftp.oops.org/pub/oops/php/pear/ePrint/ePrint-%{eprintver}.tgz
%define myexcep http://ftp.oops.org/pub/oops/php/pear/myException/myException-%{myexcepver}.tgz

Summary: PHP Extension and Application Repository framework
Summary(ko): PHP 확장및 응용 프로그램 저장소 프레임웍
Name: php-pear
Version: 1.10.5
Release: 1%{?dist}
Epoch: 100
# PEAR, Archive_Tar, XML_Util are BSD
# XML-RPC, Console_Getopt are PHP
# Structures_Graph is LGPLv2+
License: BSD and PHP and LGPLv2+
Group: Development/Languages
URL: http://pear.php.net/package/PEAR
Source0: http://download.pear.php.net/package/PEAR-%{version}.tgz
# wget 'http://svn.php.net/viewvc/pear/pear-core/trunk/install-pear.php?revision=308763&view=co' -O install-pear.php
# see http://pear.php.net/bugs/18367 - doc_dir relocation
Source1: install-pear.php
Source2: relocate.php
Source3: strip.php
Source4: LICENSE-XML_RPC
Source10: pear.sh
Source11: pecl.sh
Source12: peardev.sh
Source13: macros.pear
Source20: http://pear.php.net/get/XML_RPC-%{xmlrpcver}.tgz
Source21: http://pear.php.net/get/Archive_Tar-%{arctarver}.tgz
Source22: http://pear.php.net/get/Console_Getopt-%{getoptver}.tgz
Source23: http://pear.php.net/get/Structures_Graph-%{structver}.tgz
Source24: http://pear.php.net/get/XML_Util-%{xmlutil}.tgz

# Man pages
# https://github.com/pear/pear-core/pull/14
Source30: pear.1
Source31: pecl.1
Source32: peardev.1
# https://github.com/pear/pear-core/pull/16
Source33: pear.conf.5

# thrid party
Source104: http://pear.php.net/get/Net_Socket-1.2.2.tgz
Source105: http://pear.php.net/get/Auth_SASL-1.1.0.tgz
Source106: http://pear.php.net/get/DB-1.9.2.tgz
Source107: http://pear.php.net/get/HTTP-1.4.1.tgz
Source108: http://pear.php.net/get/Net_SMTP-1.8.0.tgz
Source109: http://pear.php.net/get/Mail-1.4.1.tgz
Source110: http://pear.php.net/get/Net_UserAgent_Detect-2.5.2.tgz
Source111: http://pear.php.net/get/XML_Parser-1.3.7.tgz
Source112: http://pear.php.net/get/DB_DataObject-1.11.5.tgz

Source10000: AliasFunc.php

# From RHEL: ignore REST cache creation failures as non-root user (#747361)
# TODO See https://github.com/pear/pear-core/commit/dfef86e05211d2abc7870209d69064d448ef53b3#PEAR/REST.php
#Patch0: php-pear-1.9.4-restcache.patch

# AnNyung Patches
Patch100: pear-annyung-alias-func.patch

BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: php-cli, php-devel, gnupg

Provides: php-pear(Console_Getopt) = %{getoptver}
Provides: php-pear(Archive_Tar) = %{arctarver}
Provides: php-pear(PEAR) = %{version}
Provides: php-pear(Structures_Graph) = %{structver}
Provides: php-pear(XML_RPC) = %{xmlrpcver}
Provides: php-pear(XML_Util) = %{xmlutil}
Obsoletes: php-pear-XML-Util <= %{xmlutil}
Provides:  php-pear-XML-Util = %{xmlutil}-%{release}
Provides: php-pear(Net_Socket) = 1.2.2
Provides: php-pear(Auth_SASL) = 1.1.0
Provides: php-pear(DB) = 1.8.2
Provides: php-pear(HTTP) = 1.4.1
Provides: php-pear(Net_SMTP) = 1.8.0
Provides: php-pear(Mail) = 1.4.1
Provides: php-pear(Net_UserAgent_Detect) = 2.5.2
Provides: php-pear(XML_Parser) = 1.3.7
Provides: php-pear(DB_DataObject) = 1.11.1.3.64
Provides: php-pear(eSystem) = %{esystemver}
Provides: php-pear(eFilesyste) = %{efilever}
Provides: php-pear(eGetopt) = %{ogetoptver}
Provides: php-pear(ePrint) = %{eprintver}
Provides: php-pear(myException) = %{myexcepver}
Requires: php-cli >= 5.1.0-1
%if %{withpear}
#Requires: pear-oops-key
BuildRequires: php-pear %{peardir}/.channels/pear.oops.org.reg
%endif


%description
PEAR is a framework and distribution system for reusable PHP
components.  This package contains the basic PEAR components.

%prep
%setup -cT

# Create a usable PEAR directory (used by install-pear.php)
for archive in %{SOURCE0} %{SOURCE21} %{SOURCE22} %{SOURCE23} %{SOURCE24} \
		%{SOURCE104} %{SOURCE105} \
		%{SOURCE106} %{SOURCE107} %{SOURCE108} \
		%{SOURCE109} %{SOURCE110} %{SOURCE111} %{SOURCE112}
do
    tar xzf  $archive --strip-components 1 || tar xzf  $archive --strip-path 1
    file=${archive##*/}
    [ -f LICENSE ] && mv LICENSE LICENSE-${file%%-*}
    [ -f README ]  && mv README  README-${file%%-*}

    tar xzf $archive 'package*xml'
    [ -f package2.xml ] && mv package2.xml ${file%%-*}.xml \
                        || mv package.xml  ${file%%-*}.xml
done
cp %{SOURCE1} %{SOURCE30} %{SOURCE31} %{SOURCE32} %{SOURCE33} .

tar xzf %{SOURCE24} package.xml
mv package.xml XML_Util.xml

# dos format to unix
find . -type f -exec perl -pi -e 's/\r\n/\n/g' {} \;

# AnNyung patches
%patch100 -p1

install -m 644 %{SOURCE10000} ./AliasFunc.php

# apply patches on used PEAR during install
# -- no patch

%build
# This is an empty build section.
%if %{withpear}
cd $RPM_SOURCE_DIR
curl -o oops-efilesystem.tgz %{efilesystem}
curl -o oops-eprint.tgz %{eprint}
curl -o oops-esystem.tgz %{esystem}
curl -o oops-ogetopt.tgz %{ogetopt}
curl -o oops-myexcep.tgz %{myexcep}
cd -
%endif

%install
rm -rf %{buildroot}

export PHP_PEAR_SYSCONF_DIR=%{_sysconfdir}/php.d
export PHP_PEAR_SIG_KEYDIR=%{_sysconfdir}/php.d/pearkeys
export PHP_PEAR_SIG_BIN=%{_bindir}/gpg
export PHP_PEAR_INSTALL_DIR=%{peardir}

# 1.4.11 tries to write to the cache directory during installation
# so it's not possible to set a sane default via the environment.
# The ${PWD} bit will be stripped via relocate.php later.
export PHP_PEAR_CACHE_DIR=%{_localstatedir}/lib/php/pear/cache
export PHP_PEAR_TEMP_DIR=%{_localstatedir}/lib/php/tmp
export PHP_PEAR_DOWNLOAD_DIR=%{_localstatedir}/lib/php/pear/download

install -d %{buildroot}%{peardir} \
           %{buildroot}${PHP_PEAR_CACHE_DIR} \
           %{buildroot}%{peardir}/.pkgxml \
           %{buildroot}%{_sysconfdir}/rpm \
           %{buildroot}${PHP_PEAR_SYSCONF_DIR}/pearkeys \
           %{buildroot}${PHP_PEAR_DOWNLOAD_DIR}

export INSTALL_ROOT=%{buildroot}

%{_bindir}/php -n %{cliopt} -dmemory_limit=64M -dshort_open_tag=0 \
         -d 'error_reporting=E_ALL&~E_DEPRECATED' -ddetect_unicode=0 \
      %{SOURCE1} -d %{peardir} \
                 -c %{_sysconfdir}/php.d \
                 -b %{_bindir} \
                 %{SOURCE0} %{SOURCE21} %{SOURCE22} %{SOURCE23} %{SOURCE24} %{SOURCE20} \
                 %{SOURCE104} %{SOURCE105} %{SOURCE106} %{SOURCE107} %{SOURCE108} %{SOURCE109} \
                 %{SOURCE110} %{SOURCE111} %{SOURCE112}

# Replace /usr/bin/* with simple scripts:
install -m 755 %{SOURCE10} %{buildroot}%{_bindir}/pear
install -m 755 %{SOURCE11} %{buildroot}%{_bindir}/pecl
install -m 755 %{SOURCE12} %{buildroot}%{_bindir}/peardev

# Sanitize the pear.conf
%{_bindir}/php -n %{cliopt} %{SOURCE2} %{buildroot}%{_sysconfdir}/php.d/pear.conf %{buildroot} | 
  %{_bindir}/php -n %{cliopt} %{SOURCE2} php://stdin $PWD > new-pear.conf
%{_bindir}/php -n %{cliopt} %{SOURCE3} new-pear.conf ext_dir |
  %{_bindir}/php -n %{cliopt} %{SOURCE3} php://stdin http_proxy > %{buildroot}%{_sysconfdir}/php.d/pear.conf

%{_bindir}/php -r "print_r(unserialize(substr(file_get_contents('%{buildroot}%{_sysconfdir}/php.d/pear.conf'),17)));"

install -m 644 -c %{SOURCE4} LICENSE-XML_RPC

install -m 644 -c %{SOURCE13} \
           %{buildroot}%{_sysconfdir}/rpm/macros.pear

install -m 644 %{SOURCE10000} %{buildroot}%{peardir}/AliasFunc.php

# apply patches on installed PEAR tree
#pushd %{buildroot}%{peardir} 
# pushd PEAR
#  %__patch -s --no-backup --fuzz 0 -p0 < %{PATCH0}
# popd
#popd

# Why this file here ?
rm -rf %{buildroot}/.depdb* %{buildroot}/.lock %{buildroot}/.channels %{buildroot}/.filemap

# Need for re-registrying XML_Util
install -m 644 XML_Util.xml %{buildroot}%{peardir}/.pkgxml/

%if %{withpear}
for pkg in `ls $RPM_SOURCE_DIR/oops-*.tgz`
do
	%{__pear} install \
		--offline \
		--ignore-errors \
		--packagingroot=%{buildroot} $pkg
	%{__rm} -f $pkg
done
%endif

# The man pages
install -d $RPM_BUILD_ROOT%{_mandir}/man1
install -p -m 644 pear.1 pecl.1 peardev.1 $RPM_BUILD_ROOT%{_mandir}/man1/
install -d $RPM_BUILD_ROOT%{_mandir}/man5
install -p -m 644 pear.conf.5 $RPM_BUILD_ROOT%{_mandir}/man5/

%check
# Check that no bogus paths are left in the configuration, or in
# the generated registry files.
grep %{buildroot} %{buildroot}%{_sysconfdir}/php.d/pear.conf && exit 1
grep %{_libdir} %{buildroot}%{_sysconfdir}/php.d/pear.conf && exit 1
grep '"/tmp"' %{buildroot}%{_sysconfdir}/php.d/pear.conf && exit 1
grep /usr/local %{buildroot}%{_sysconfdir}/php.d/pear.conf && exit 1
grep -rl %{buildroot} %{buildroot} && exit 1


%clean
rm -rf %{buildroot}
rm new-pear.conf


%triggerpostun -- php-pear-XML-Util
# re-register extension unregistered during postun of obsoleted php-pear-XML-Util
%{_bindir}/pear install --nodeps --soft --force --register-only %{pear_xmldir}/XML_Util.xml >/dev/null || :

%post
%{_bindir}/pear channel-update pear.oops.org >& /dev/null
if test ! -d /var/lib/php/tmp; then
    mkdir -p /var/lib/php/tmp
    chmod 755 /var/lib/php/tmp
    chown apache.apache /var/lib/php/tmp
fi

%files
%defattr(-,root,root,-)
%{peardir}
%{_bindir}/*
%config(noreplace) %{_sysconfdir}/php.d/pear.conf
%config %{_sysconfdir}/rpm/macros.pear
%dir %{_sysconfdir}/php.d/pearkeys
%dir %{_localstatedir}/lib/php/pear
%dir %{_localstatedir}/lib/php/pear/cache
%dir %{_localstatedir}/lib/php/pear/download
%{_mandir}/man1/*.1*
%{_mandir}/man5/*.5*

%changelog
* Sun Feb 11 2018 JoungKyun.Kim <http://oops.org> 203:1.10.5-1%{?dist}
- update 1.10.5
- update Archive_Tar 1.4.3
- update Auth_SASL 1.1.0
- update Mail 1.4.1
- update Net_SMTP 1.8.0
- update Net_Socket 1.2.2
- update PEAR 1.10.5
- update XML_Parser 1.3.7
- update XML_Util 1.4.3

* Thu Dec 31 2015 JoungKyun.Kim <http://oops.org> 100:1.10.1-2%{?dist}
- update esystem-1.0.2
- update ogetopt-1.0.3

* Thu Dec 31 2015 JoungKyun.Kim <http://oops.org> 100:1.10.1-1%{?dist}
- update 1.10.1 for PHP7 support

* Mon Sep  7 2015 JoungKyun.Kim <http://oops.org> 100:1.9.5-1.epel%{?dist}
- update 1.9.5

* Mon Sep  7 2015 JoungKyun.Kim <http://oops.org> 100:1.9.4-7.epel%{?dist}
- repackaging based on ELEP 7

* Thu Feb  6 2014 JoungKyun.Kim <http://oops.org> 203:1.9.4-6.cf16%{?dist}
- update eFilesystem 1.0.4
  . PHP 5.5 지원
  . fixed eFilesystem::make_ini
    + stdClass type 처리 못하는 문제 수정
    + 빈값일 경우 newline 사라지는 문제 수정 및, null value 추가
- update ePrint 1.0.6
  . PHP 5.5 지원
  . fixed ePrint::wordwrap
    + UTF-8 mode 이상 동작 수정
    + 다음 라인과 merge할 경우 문장이 중복되는 문제 수정
  . call by reference로 사용할 수 있는 trim, ltrim, rtrim method 추가
- update oGetopt 1.0.2
  . fixed undeclare _() error


* Mon Oct 14 2013 JoungKyun.Kim <http://oops.org> 203:1.9.4-5.cf16%{?dist}
- fixed myException dependency problems

* Tue Sep 24 2013 JoungKyun.Kim <http://oops.org> 203:1.9.4-4.fc16%{?dist}
- update eFilesystem 1.0.3
- update ePrint 1.0.4
- update Archive_Tar 1.3.11
- update DB_DataObject 1.11.2
- update Net_SMTP 1.6.2
- update Net_Socket 1.0.14

* Tue Oct 30 2012 JoungKyun.Kim <http://oops.org> 203:1.9.4-3.fc16%{?dist}
- update eFilesystem 1.0.2
- update ePrint 1.0.3
- update oGetopt 1.0.1
- update Archive_Tar 1.3.10
- update Auth_SASL 1.0.6
- update DB 1.7.14
- update DB_DataObject 1.10.0
- update Net_SMTP 1.6.1
- update XML_RPC 1.5.5

* Wed May 23 2012 JoungKyun.Kim <http://oops.org> 203:1.9.4-2.fc16%{?dist}
- fixed typo of pecl command

* Sun Mar  4 2012 JoungKyun.Kim <http://oops.org> 203:1.9.4-1.fc16%{?dist}
- update 1.9.4
- add oops/ePrint

* Tue May 10 2011 JoungKyun.Kim <http://oops.org> 203:1.9.2-3.fc16%{?dist}
- update
